/****************************************************************/
/*                                                              */
/*  27512.v                                                     */
/*                                                              */
/*  Author:   Tianmo Lei (tm2008@yahoo.com)                     */
/*  Version:  V0.1                                              */
/*  Date:     Feb 15, 2002                                      */
/*  Additional information is avaliable in the Readme.txt       */
/*                                                              */
/****************************************************************/
/*                                                              */
/* Copyright (C) 2002 Tianmo Lei                                */
/*                                                              */
/* This source file may be used and distributed without         */
/* restriction provided that this copyright statement is not    */
/* removed from the file and that any derivative work contains  */
/* the original copyright notice and the associated disclaimer. */
/*                                                              */
/* This source file is free software; you can redistribute it   */
/* and/or modify it under the terms of the GNU Lesser General   */
/* Public License as published by the Free Software Foundation; */
/* either version 2.1 of the License, or (at your option) any   */
/* later version.                                               */
/* This source is distributed in the hope that it will be       */
/* useful, but WITHOUT ANY WARRANTY; without even the implied   */
/* warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR      */
/* PURPOSE. See the GNU Lesser General Public License for more  */
/* details.                                                     */
/*                                                              */
/****************************************************************/

module \27512 (
 .\1 ( A[15] ),.\2 ( A[12] ),.\3 ( A[7] ),.\4 ( A[6] ),
 .\5 ( A[5] ),.\6 ( A[4] ),.\7 ( A[3] ),.\8 ( A[2] ),
 .\9 ( A[1] ),.\10 ( A[0] ),.\11 ( Q[0] ),.\12 ( Q[1] ),
 .\13 ( Q[2] ),.\14 ( GND ),.\15 ( Q[3] ),.\16 ( Q[4] ),
 .\17 ( Q[5] ),.\18 ( Q[6] ),.\19 ( Q[7] ),.\20 ( CE ),
 .\21 ( A[10] ),.\22 ( OE ),.\23 ( A[11] ),.\24 ( A[9] ),
 .\25 ( A[8] ),.\26 ( A[13] ),.\27 ( A[14] ),.\28 ( VCC )
);
 
input CE, OE;
input [15:0] A;
input VCC, GND;
output [7:0] Q;
 
reg [7:0] Q;
reg [7:0] rom[0:65535];
 
initial
begin
  $readmemh ("rom.hex", rom);
end

always @(A or CE or OE)
  if(~CE & ~OE ) Q = rom[A];
  else Q = 8'bz;
 
endmodule
 
