/****************************************************************/
/*                                                              */
/*  L8051.v                                                     */
/*                                                              */
/*  Author:   Tianmo Lei (tm2008@yahoo.com)                     */
/*  Version:  V0.1                                              */
/*  Date:     Feb 15, 2002                                      */
/*  Additional information is avaliable in the Readme.txt       */
/*                                                              */
/****************************************************************/
/*                                                              */
/* Copyright (C) 2002 Tianmo Lei                                */
/*                                                              */
/* This source file may be used and distributed without         */
/* restriction provided that this copyright statement is not    */
/* removed from the file and that any derivative work contains  */
/* the original copyright notice and the associated disclaimer. */
/*                                                              */
/* This source file is free software; you can redistribute it   */
/* and/or modify it under the terms of the GNU Lesser General   */
/* Public License as published by the Free Software Foundation; */
/* either version 2.1 of the License, or (at your option) any   */
/* later version.                                               */
/* This source is distributed in the hope that it will be       */
/* useful, but WITHOUT ANY WARRANTY; without even the implied   */
/* warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR      */
/* PURPOSE. See the GNU Lesser General Public License for more  */
/* details.                                                     */
/*                                                              */
/****************************************************************/

module \64kram
 ( .\1 ( NC ), .\2 ( NC ), .\3 ( A[14] ), .\4 ( A[12] ),
 .\5 ( A[7] ), .\6 ( A[6] ), .\7 ( A[5] ), .\8 ( A[4] ),
 .\9 ( A[3] ), .\10 ( A[2] ), .\11 ( A[1] ), .\12 ( A[0] ),
 .\13 ( DQ[0] ), .\14 ( DQ[1] ), .\15 ( DQ[2] ), .\16 ( VSS ),
 .\17 ( DQ[3] ), .\18 ( DQ[4] ), .\19 ( DQ[5] ), .\20 ( DQ[6] ),
 .\21 ( DQ[7] ), .\22 ( CE ), .\23 ( A[10] ), .\24 ( OE ),
 .\25 ( A[11] ), .\26 ( A[9] ), .\27 ( A[8] ), .\28 ( A[13] ),
 .\29 ( WE ), .\30 ( NC ), .\31 ( A[15] ), .\32 ( VCC ) );

input [15:0] A;
input CE,OE,WE; 
input VCC, VSS, NC;
inout [7:0] DQ;
 
reg [7:0] Q;
reg [7:0] sram[0:65535];
wire [7:0] D = DQ;
wire [7:0] DQ = (~CE & ~OE & WE) ? Q : 8'bz;

always @(A or CE or OE or WE)
  if(~CE & ~OE & WE) Q = sram[A];
  else Q = 8'bz;
 
always @( WE or CE or D )
  if(~WE & ~CE ) sram[A] = D;
 
endmodule
 
