/****************************************************************/
/*                                                              */
/*  74373.v                                                     */
/*                                                              */
/*  Author:   Tianmo Lei (tm2008@yahoo.com)                     */
/*  Version:  V0.1                                              */
/*  Date:     Feb 15, 2002                                      */
/*  Additional information is avaliable in the Readme.txt       */
/*                                                              */
/****************************************************************/
/*                                                              */
/* Copyright (C) 2002 Tianmo Lei                                */
/*                                                              */
/* This source file may be used and distributed without         */
/* restriction provided that this copyright statement is not    */
/* removed from the file and that any derivative work contains  */
/* the original copyright notice and the associated disclaimer. */
/*                                                              */
/* This source file is free software; you can redistribute it   */
/* and/or modify it under the terms of the GNU Lesser General   */
/* Public License as published by the Free Software Foundation; */
/* either version 2.1 of the License, or (at your option) any   */
/* later version.                                               */
/* This source is distributed in the hope that it will be       */
/* useful, but WITHOUT ANY WARRANTY; without even the implied   */
/* warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR      */
/* PURPOSE. See the GNU Lesser General Public License for more  */
/* details.                                                     */
/*                                                              */
/****************************************************************/

primitive latch(q, e, d);
input e, d;
output q;
reg q;
table
11:?:1;
10:?:0;
0?:?:-;
endtable
endprimitive

module \74373 ( .\1 ( oe ), .\2 ( q[0] ), .\3 ( d[0] ), .\4 ( d[1] ), 
.\5 ( q[1] ), .\6 ( q[2] ), .\7 ( d[2] ), .\8 ( d[3] ),
.\9 ( q[3] ), .\10 ( gnd ), .\11 ( e ), .\12 ( q[4] ),
.\13 ( d[4] ), .\14 ( d[5] ), .\15 ( q[5] ), .\16 ( q[6] ),
.\17 ( d[6] ), .\18 ( d[7] ), .\19 ( q[7] ), .\20 ( vcc ));

input	[7:0] d;
output	[7:0] q;
input	e, oe;
input	vcc, gnd;

latch latch0 ( q[0], e, d[0] );
latch latch1 ( q[1], e, d[1] );
latch latch2 ( q[2], e, d[2] );
latch latch3 ( q[3], e, d[3] );
latch latch4 ( q[4], e, d[4] );
latch latch5 ( q[5], e, d[5] );
latch latch6 ( q[6], e, d[6] );
latch latch7 ( q[7], e, d[7] );

endmodule


