/****************************************************************/
/*                                                              */
/*  test.v                                                     */
/*                                                              */
/*  Author:   Tianmo Lei (tm2008@yahoo.com)                     */
/*  Version:  V0.1                                              */
/*  Date:     Feb 15, 2002                                      */
/*  Additional information is avaliable in the Readme.txt       */
/*                                                              */
/****************************************************************/
/*                                                              */
/* Copyright (C) 2002 Tianmo Lei                                */
/*                                                              */
/* This source file may be used and distributed without         */
/* restriction provided that this copyright statement is not    */
/* removed from the file and that any derivative work contains  */
/* the original copyright notice and the associated disclaimer. */
/*                                                              */
/* This source file is free software; you can redistribute it   */
/* and/or modify it under the terms of the GNU Lesser General   */
/* Public License as published by the Free Software Foundation; */
/* either version 2.1 of the License, or (at your option) any   */
/* later version.                                               */
/* This source is distributed in the hope that it will be       */
/* useful, but WITHOUT ANY WARRANTY; without even the implied   */
/* warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR      */
/* PURPOSE. See the GNU Lesser General Public License for more  */
/* details.                                                     */
/*                                                              */
/****************************************************************/

`timescale 100ps/100ps
 
module test ();
 
reg	xtal1,rst;
wire	RST = rst; 
wire	ea = 0;
wire	ale,psen;
wire	[7:0] p0, p1, p2, p3;
wire	[7:0] a;
supply1 VCC;
supply0 GND;
 
l8051 l8051  (  .\1 (p1[0]),  .\2 (p1[1]),  .\3 (p1[2]),  .\4 (p1[3]),
 		.\5 (p1[4]),  .\6 (p1[5]),  .\7 (p1[6]),  .\8 (p1[7]),
 		.\9 (rst),    .\10 (p3[0]), .\11 (p3[1]), .\12 (p3[2]),
 		.\13 (p3[3]), .\14 (p3[4]), .\15 (p3[5]), .\16 (p3[6]),
 		.\17 (p3[7]), .\18 (xtal2), .\19 (xtal1), .\20 (GND),
 		.\21 (p2[0]), .\22 (p2[1]), .\23 (p2[2]), .\24 (p2[3]),
 		.\25 (p2[4]), .\26 (p2[5]), .\27 (p2[6]), .\28 (p2[7]),
 		.\29 (psen),  .\30 (ale),   .\31 (ea),	  .\32 (p0[7]),
 		.\33 (p0[6]), .\34 (p0[5]), .\35 (p0[4]), .\36 (p0[3]),
 		.\37 (p0[2]), .\38 (p0[1]), .\39 (p0[0]), .\40 (VCC) );
 
\27512 rom   ( 	.\1 (p2[7]), .\2 (p2[4]), .\3 (a[7]),  .\4 (a[6]),
 		.\5 (a[5]),  .\6 (a[4]),  .\7 (a[3]),  .\8 (a[2]),
 		.\9 (a[1]),  .\10 (a[0]), .\11 (p0[0]),.\12 (p0[1]),
 		.\13 (p0[2]),.\14 (GND ), .\15 (p0[3]),.\16 (p0[4]),
 		.\17 (p0[5]),.\18 (p0[6]),.\19 (p0[7]),.\20 (GND),
 		.\21 (p2[2]),.\22 (psen), .\23 (p2[3]),.\24 (p2[1]),
 		.\25 (p2[0]),.\26 (p2[5]),.\27 (p2[6]),.\28 (VCC) );
 
\64kram ram  (	.\1 (GND),   .\2 (GND),   .\3 (p2[6]), .\4 (p2[4]),
 		.\5 (a[7]),  .\6 (a[6]),  .\7 (a[5]),  .\8 (a[4]),
 		.\9 (a[3]),  .\10 (a[2]), .\11 (a[1]), .\12 (a[0]),
 		.\13 (p0[0]),.\14 (p0[1]),.\15 (p0[2]),.\16 (GND),
 		.\17 (p0[3]),.\18 (p0[4]),.\19 (p0[5]),.\20 (p0[6]),
 		.\21 (p0[7]),.\22 (GND),  .\23 (p2[2]),.\24 (p3[7]),
 		.\25 (p2[3]),.\26 (p2[1]),.\27 (p2[0]),.\28 (p2[5]),
 		.\29 (p3[6]),.\30 (GND),  .\31 (p2[7]),.\32 (VCC) );
 
\74373 latch (  .\1 (GND),   .\2 (a[0]),  .\3 (p0[0]), .\4 (p0[1]),
 		.\5 (a[1]),  .\6 (a[2]),  .\7 (p0[2]), .\8 (p0[3]),
 		.\9 (a[3]),  .\10 (GND),  .\11 (ale),  .\12 (a[4]),
 		.\13 (p0[4]),.\14 (p0[5]),.\15 (a[5]), .\16 (a[6]),
 		.\17 (p0[6]),.\18 (p0[7]),.\19 (a[7]), .\20 (VCC) );
 
 
`include "chk.v"
 
initial
begin
  xtal1 = 0;
  rst = 1;
  #300 rst = 0;
  #100000 $stop; 
end
  
always #2 xtal1 = ~xtal1; // 5Ghz
 
reg exint0,exint1;	// for external interrupt test
assign p3[2]=exint0; 
assign p3[3]=exint1; 
initial
begin
  exint0=1; exint1=1;
  #600 exint1=0;
  #300 exint0=0; 
  #300 exint1=1; 
  #300 exint0=1; 
end

reg sio;		// for sio test, loopback txd to rxd
always @(posedge ale) sio=p3[1];
assign p3[0]=sio;
 
endmodule
 
  
  
 
